#include <avr\io.h>
#define F_CPU 16000000
#include <util/delay.h>

#define TO_LED_1 (1 << PB0)
#define TO_LED_2 (1 << PB1)
#define TO_LED_3 (1 << PB0) | (1 << PB1)
#define TO_LED_4 (1 << PB2)
#define TO_LED_5 (1 << PB2) | (1 << PB0)
#define TO_LED_6 (1 << PB2) | (1 << PB1)
#define TO_LED_7 (1 << PB2) | (1 << PB1) | (1 << PB0)
#define TO_LED_8 (1 << PB3)
#define TO_LED_9 (1 << PB3) | (1 << PB0)

#define TO_LED_10 (1 << PB4)
#define TO_LED_20 (1 << PB5)
#define TO_LED_30 (1 << PB4) | (1 << PB5)
#define TO_LED_40 (1 << PB6)
#define TO_LED_50 (1 << PB6) | (1 << PB4)


int hour = 0, min = 0, sec = 0, edit = 0;


unsigned char light1(int x) { //pornire led corespunzator primei cifre din numar

	switch(x % 10) {
		case 1: return TO_LED_1;
		case 2:	return TO_LED_2;
		case 3:	return TO_LED_3;
		case 4: return TO_LED_4;
		case 5:	return TO_LED_5;
		case 6: return TO_LED_6;
		case 7:	return TO_LED_7;
		case 8:	return TO_LED_8;
		case 9:	return TO_LED_9;
	}
	
	return 0;
}


unsigned char light2(int x) { //pornire led corespunzator cifrei doi din numar

	switch((x/10) % 10) {
		case 1: return TO_LED_10;
		case 2:	return TO_LED_20;
		case 3:	return TO_LED_30;
		case 4:	return TO_LED_40;
		case 5:	return TO_LED_50;
	}
	
	return 0;
}


void display() {

	PORTC = PORTD = 0;	
	PORTA &= ~((1<<PB0) | (1<<PB1) | (1<<PB2) | (1<<PB3) | (1<<PB4) | (1<<PB5));


	PORTD |= light1(sec);
	PORTD |= light2(sec);	
	
	PORTC |= light1(min);
	PORTC |= light2(min);
	
	PORTA |= light1(hour);
	PORTA |= light2(hour);
}


int main() {

	int i;

	DDRD |= 0xFF;
	DDRA |= ((1<<PB0) | (1<<PB1) | (1<<PB2) | (1<<PB3) | (1<<PB4) | (1<<PB5));
	DDRC |= 0xFF;
	
	PORTC = 0xFF;
	PORTA |= ((1<<PB0) | (1<<PB1) | (1<<PB2) | (1<<PB3) | (1<<PB4) | (1<<PB5));
	PORTD |= 0xFF;
	_delay_ms(500);
	
	DDRA &= ~((1 << PD6) | (1 << PD7));  
	PORTA |= ((1 << PD6) | (1 << PD7));  

	while(1) {
	
		display();	
		
		if(!edit) sec++;
		else PORTD |= (1 << PD7);
		
		edit = 0;
		
		if(sec == 60) {
			min++;
			sec = 0;
		}
		
		if(min == 60) {
			hour++;
			min = 0;
		}
		
		if(hour == 24) 
			hour = min = sec = 0;
	
			for (i=0; i<4; i++) {
				_delay_ms(250);
				if (!(PINA & (1 << PD6))) {
					min++;
					edit = 1;
					break;
					
				} else {
					if (!(PINA & (1 << PD7))) {
						hour++;
						edit = 1;
						break;
					}
				}	
			}
	}
}